libvisio::VSDXParser Class Reference

`#include <VSDXParser.h>`

Inheritance diagram for libvisio::VSDXParser:

## Public Member Functions

| VSDXParser (librevenge::RVNGInputStream *input, librevenge::RVNGDrawingInterface *painter)
| ~VSDXParser () override
bool | parseMain () override
bool | extractStencils () override
Public Member Functions inherited from libvisio::VSDXMLParserBase
| VSDXMLParserBase ()
virtual | ~VSDXMLParserBase ()

## Private Member Functions

| VSDXParser ()
| VSDXParser (const VSDXParser &)
VSDXParser & | operator= (const VSDXParser &)
xmlChar * | readStringData (xmlTextReaderPtr reader) override
int | getElementToken (xmlTextReaderPtr reader) override
int | getElementDepth (xmlTextReaderPtr reader) override
int | skipSection (xmlTextReaderPtr reader)
bool | parseDocument (librevenge::RVNGInputStream *input, const char *name)
bool | parseMasters (librevenge::RVNGInputStream *input, const char *name)
bool | parseMaster (librevenge::RVNGInputStream *input, const char *name)
bool | parsePages (librevenge::RVNGInputStream *input, const char *name)
bool | parsePage (librevenge::RVNGInputStream *input, const char *name)
bool | parseTheme (librevenge::RVNGInputStream *input, const char *name)
void | parseMetaData (librevenge::RVNGInputStream *input, VSDXRelationships &rels)
void | processXmlDocument (librevenge::RVNGInputStream *input, VSDXRelationships &rels)
void | processXmlNode (xmlTextReaderPtr reader)
void | extractBinaryData (librevenge::RVNGInputStream *input, const char *name)
void | readPageSheetProperties (xmlTextReaderPtr reader)
void | readStyleProperties (xmlTextReaderPtr reader)
void | readShapeProperties (xmlTextReaderPtr reader)
void | getBinaryData (xmlTextReaderPtr reader) override
void | readLayer (xmlTextReaderPtr reader)
void | readParagraph (xmlTextReaderPtr reader)
void | readCharacter (xmlTextReaderPtr reader)
void | readFonts (xmlTextReaderPtr reader)
void | readTabs (xmlTextReaderPtr reader)
void | readTabRow (xmlTextReaderPtr reader)
int | readExtendedColourData (Colour &value, long &idx, xmlTextReaderPtr reader)
int | readExtendedColourData (Colour &value, xmlTextReaderPtr reader)
int | readExtendedColourData (std::optional< Colour > &value, xmlTextReaderPtr reader)
int | readDoubleData (std::optional< double > &value, xmlTextReaderPtr reader)
int | readDoubleData (double &value, xmlTextReaderPtr reader)
int | readBoolData (std::optional< bool > &value, xmlTextReaderPtr reader)
int | readBoolData (bool &value, xmlTextReaderPtr reader)
int | readLongData (std::optional< long > &value, xmlTextReaderPtr reader)
int | readLongData (long &value, xmlTextReaderPtr reader)
int | readStringData (VSDName &text, xmlTextReaderPtr reader)

## Private Attributes

librevenge::RVNGInputStream * | m_input
librevenge::RVNGDrawingInterface * | m_painter
int | m_currentDepth
VSDXRelationships * | m_rels
VSDXTheme | m_currentTheme
std::set< std::string > | m_visitedParts

## Additional Inherited Members

Protected Member Functions inherited from libvisio::VSDXMLParserBase
int | readByteData (unsigned char &value, xmlTextReaderPtr reader)
int | readByteData (std::optional< unsigned char > &value, xmlTextReaderPtr reader)
int | readUnsignedData (std::optional< unsigned > &value, xmlTextReaderPtr reader)
int | readLongData (std::optional< long > &value, xmlTextReaderPtr reader)
int | readLongData (long &value, xmlTextReaderPtr reader)
int | readDoubleData (std::optional< double > &value, xmlTextReaderPtr reader)
int | readDoubleData (double &value, xmlTextReaderPtr reader)
int | readBoolData (std::optional< bool > &value, xmlTextReaderPtr reader)
int | readBoolData (bool &value, xmlTextReaderPtr reader)
int | readExtendedColourData (Colour &value, long &idx, xmlTextReaderPtr reader)
int | readExtendedColourData (Colour &value, xmlTextReaderPtr reader)
int | readExtendedColourData (std::optional< Colour > &value, xmlTextReaderPtr reader)
bool | readColourOrColourIndex (Colour &value, long &idx, xmlTextReaderPtr reader)
int | readNURBSData (std::optional< NURBSData > &data, xmlTextReaderPtr reader)
int | readPolylineData (std::optional< PolylineData > &data, xmlTextReaderPtr reader)
int | readStringData (VSDName &text, xmlTextReaderPtr reader)
void | readTriggerId (unsigned &id, xmlTextReaderPtr reader)
unsigned | getIX (xmlTextReaderPtr reader)
virtual void | _handleLevelChange (unsigned level)
void | _flushShape ()
void | readEllipticalArcTo (xmlTextReaderPtr reader)
void | readEllipse (xmlTextReaderPtr reader)
void | readGeometry (xmlTextReaderPtr reader)
void | readMoveTo (xmlTextReaderPtr reader)
void | readLineTo (xmlTextReaderPtr reader)
void | readArcTo (xmlTextReaderPtr reader)
void | readNURBSTo (xmlTextReaderPtr reader)
void | readPolylineTo (xmlTextReaderPtr reader)
void | readInfiniteLine (xmlTextReaderPtr reader)
void | readRelCubBezTo (xmlTextReaderPtr reader)
void | readRelEllipticalArcTo (xmlTextReaderPtr reader)
void | readRelLineTo (xmlTextReaderPtr reader)
void | readRelMoveTo (xmlTextReaderPtr reader)
void | readRelQuadBezTo (xmlTextReaderPtr reader)
void | readForeignData (xmlTextReaderPtr reader)
void | readShape (xmlTextReaderPtr reader)
void | readColours (xmlTextReaderPtr reader)
void | readPage (xmlTextReaderPtr reader)
void | readText (xmlTextReaderPtr reader)
void | readCharIX (xmlTextReaderPtr reader)
void | readParaIX (xmlTextReaderPtr reader)
void | readLayerIX (xmlTextReaderPtr reader)
void | readLayerMember (xmlTextReaderPtr reader)
void | readStyleSheet (xmlTextReaderPtr reader)
void | readPageSheet (xmlTextReaderPtr reader)
void | readSplineStart (xmlTextReaderPtr reader)
void | readSplineKnot (xmlTextReaderPtr reader)
void | readStencil (xmlTextReaderPtr reader)
void | handlePagesStart (xmlTextReaderPtr reader)
void | handlePagesEnd (xmlTextReaderPtr reader)
void | handlePageStart (xmlTextReaderPtr reader)
void | handlePageEnd (xmlTextReaderPtr reader)
void | handleMastersStart (xmlTextReaderPtr reader)
void | handleMastersEnd (xmlTextReaderPtr reader)
void | handleMasterStart (xmlTextReaderPtr reader)
void | handleMasterEnd (xmlTextReaderPtr reader)
void | skipPages (xmlTextReaderPtr reader)
void | skipMasters (xmlTextReaderPtr reader)
Protected Attributes inherited from libvisio::VSDXMLParserBase
VSDCollector * | m_collector
VSDStencils | m_stencils
std::unique_ptr< VSDStencil > | m_currentStencil
VSDShape | m_shape
bool | m_isStencilStarted
unsigned | m_currentStencilID
bool | m_extractStencils
bool | m_isInStyles
unsigned | m_currentLevel
unsigned | m_currentShapeLevel
std::map< unsigned, Colour > | m_colours
VSDFieldList | m_fieldList
VSDShapeList | m_shapeList
librevenge::RVNGBinaryData | m_currentBinaryData
std::stack< VSDShape > | m_shapeStack
std::stack< unsigned > | m_shapeLevelStack
bool | m_isShapeStarted
bool | m_isPageStarted
VSDGeometryList * | m_currentGeometryList
unsigned | m_currentGeometryListIndex
std::map< unsigned, VSDName > | m_fonts
std::map< unsigned, VSDTabStop > * | m_currentTabSet
XMLErrorWatcher * | m_watcher

## Constructor & Destructor Documentation

## VSDXParser() [1/3]

libvisio::VSDXParser::VSDXParser | ( | librevenge::RVNGInputStream * | input,
|  | librevenge::RVNGDrawingInterface * | painter )

explicit

Referenced by operator=(), and VSDXParser().

## ~VSDXParser()

libvisio::VSDXParser::~VSDXParser | ( |  | ) |

override

## VSDXParser() [2/3]

libvisio::VSDXParser::VSDXParser | ( |  | ) |

private

## VSDXParser() [3/3]

libvisio::VSDXParser::VSDXParser | ( | const VSDXParser & |  | ) |

private

## Member Function Documentation

## extractBinaryData()

void libvisio::VSDXParser::extractBinaryData | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by getBinaryData(), and processXmlDocument().

## extractStencils()

bool libvisio::VSDXParser::extractStencils | ( |  | ) |

override virtual

Implements libvisio::VSDXMLParserBase.

## getBinaryData()

void libvisio::VSDXParser::getBinaryData | ( | xmlTextReaderPtr | reader | ) |

override private virtual

Implements libvisio::VSDXMLParserBase.

## getElementDepth()

int libvisio::VSDXParser::getElementDepth | ( | xmlTextReaderPtr | reader | ) |

override private virtual

Implements libvisio::VSDXMLParserBase.

Referenced by processXmlNode(), readPageSheetProperties(), and readStyleProperties().

## getElementToken()

int libvisio::VSDXParser::getElementToken | ( | xmlTextReaderPtr | reader | ) |

override private virtual

Implements libvisio::VSDXMLParserBase.

Referenced by processXmlNode(), readCharacter(), readFonts(), readLayer(), readPageSheetProperties(), readParagraph(), readShapeProperties(), readStyleProperties(), readTabRow(), readTabs(), and skipSection().

## operator=()

VSDXParser & libvisio::VSDXParser::operator= | ( | const VSDXParser & |  | ) |

private

## parseDocument()

bool libvisio::VSDXParser::parseDocument | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by parseMain().

## parseMain()

bool libvisio::VSDXParser::parseMain | ( |  | ) |

override virtual

Implements libvisio::VSDXMLParserBase.

Referenced by extractStencils().

## parseMaster()

bool libvisio::VSDXParser::parseMaster | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by processXmlDocument().

## parseMasters()

bool libvisio::VSDXParser::parseMasters | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by parseDocument().

## parseMetaData()

void libvisio::VSDXParser::parseMetaData | ( | librevenge::RVNGInputStream * | input,
|  | libvisio::VSDXRelationships & | rels )

private

Referenced by parseMain().

## parsePage()

bool libvisio::VSDXParser::parsePage | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by processXmlDocument().

## parsePages()

bool libvisio::VSDXParser::parsePages | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by parseDocument().

## parseTheme()

bool libvisio::VSDXParser::parseTheme | ( | librevenge::RVNGInputStream * | input,
|  | const char * | name )

private

Referenced by parseDocument().

## processXmlDocument()

void libvisio::VSDXParser::processXmlDocument | ( | librevenge::RVNGInputStream * | input,
|  | VSDXRelationships & | rels )

private

Referenced by parseDocument(), parseMaster(), parseMasters(), parsePage(), and parsePages().

## processXmlNode()

void libvisio::VSDXParser::processXmlNode | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by processXmlDocument(), and readShapeProperties().

## readBoolData() [1/2]

int libvisio::VSDXMLParserBase::readBoolData | ( | bool & | value,
|  | xmlTextReaderPtr | reader )

private

## readBoolData() [2/2]

int libvisio::VSDXMLParserBase::readBoolData | ( | std::optional< bool > & | value,
|  | xmlTextReaderPtr | reader )

private

Referenced by readShapeProperties().

## readCharacter()

void libvisio::VSDXParser::readCharacter | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by readShapeProperties(), and readStyleProperties().

## readDoubleData() [1/2]

int libvisio::VSDXMLParserBase::readDoubleData | ( | double & | value,
|  | xmlTextReaderPtr | reader )

private

## readDoubleData() [2/2]

int libvisio::VSDXMLParserBase::readDoubleData | ( | std::optional< double > & | value,
|  | xmlTextReaderPtr | reader )

private

Referenced by readPageSheetProperties(), readShapeProperties(), readStyleProperties(), and readTabRow().

## readExtendedColourData() [1/3]

int libvisio::VSDXMLParserBase::readExtendedColourData | ( | Colour & | value,
|  | long & | idx,
|  | xmlTextReaderPtr | reader )

private

Referenced by readShapeProperties(), and readStyleProperties().

## readExtendedColourData() [2/3]

int libvisio::VSDXMLParserBase::readExtendedColourData | ( | Colour & | value,
|  | xmlTextReaderPtr | reader )

private

## readExtendedColourData() [3/3]

int libvisio::VSDXMLParserBase::readExtendedColourData | ( | std::optional< Colour > & | value,
|  | xmlTextReaderPtr | reader )

private

## readFonts()

void libvisio::VSDXParser::readFonts | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by processXmlNode().

## readLayer()

void libvisio::VSDXParser::readLayer | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by readPageSheetProperties().

## readLongData() [1/2]

int libvisio::VSDXMLParserBase::readLongData | ( | long & | value,
|  | xmlTextReaderPtr | reader )

private

## readLongData() [2/2]

int libvisio::VSDXMLParserBase::readLongData | ( | std::optional< long > & | value,
|  | xmlTextReaderPtr | reader )

private

Referenced by readShapeProperties(), and readStyleProperties().

## readPageSheetProperties()

void libvisio::VSDXParser::readPageSheetProperties | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by processXmlNode().

## readParagraph()

void libvisio::VSDXParser::readParagraph | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by readShapeProperties(), and readStyleProperties().

## readShapeProperties()

void libvisio::VSDXParser::readShapeProperties | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by processXmlNode().

## readStringData() [1/2]

int libvisio::VSDXMLParserBase::readStringData | ( | libvisio::VSDName & | text,
|  | xmlTextReaderPtr | reader )

private

## readStringData() [2/2]

xmlChar * libvisio::VSDXParser::readStringData | ( | xmlTextReaderPtr | reader | ) |

override private virtual

Implements libvisio::VSDXMLParserBase.

Referenced by readShapeProperties().

## readStyleProperties()

void libvisio::VSDXParser::readStyleProperties | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by processXmlNode().

## readTabRow()

void libvisio::VSDXParser::readTabRow | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by readTabs().

## readTabs()

void libvisio::VSDXParser::readTabs | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by readShapeProperties().

## skipSection()

int libvisio::VSDXParser::skipSection | ( | xmlTextReaderPtr | reader | ) |

private

Referenced by readShapeProperties().

## Member Data Documentation

## m_currentDepth

int libvisio::VSDXParser::m_currentDepth

private

Referenced by getElementDepth(), processXmlDocument(), and VSDXParser().

## m_currentTheme

VSDXTheme libvisio::VSDXParser::m_currentTheme

private

Referenced by parseDocument(), parseTheme(), and VSDXParser().

## m_input

librevenge::RVNGInputStream* libvisio::VSDXParser::m_input

private

Referenced by getBinaryData(), parseMain(), processXmlDocument(), and VSDXParser().

## m_painter

librevenge::RVNGDrawingInterface* libvisio::VSDXParser::m_painter

private

Referenced by parseMain(), and VSDXParser().

## m_rels

VSDXRelationships* libvisio::VSDXParser::m_rels

private

Referenced by getBinaryData(), processXmlDocument(), and VSDXParser().

## m_visitedParts

std::set<std::string> libvisio::VSDXParser::m_visitedParts

private

Referenced by processXmlDocument().

The documentation for this class was generated from the following files:

- VSDXParser.h
- VSDXParser.cpp